package com.neueda.jetbrains.plugin.graphdb.language.cypher.completion.metadata;

import com.neueda.jetbrains.plugin.graphdb.language.cypher.completion.metadata.elements.*;

import java.util.List;
import java.util.Optional;

public interface CypherMetadataProviderService {

    void wipeAll();

    void wipeContainer(String sourceId);

    CypherMetadataContainer getContainer(String sourceId);

    List<CypherLabelElement> getLabels();

    List<CypherRelationshipTypeElement> getRelationshipTypes();

    List<CypherPropertyKeyElement> getPropertyKeys();

    List<CypherProcedureElement> getProcedures();

    List<CypherUserFunctionElement> getUserFunctions();

    Optional<CypherLabelElement> findLabel(String labelName);

    Optional<CypherRelationshipTypeElement> findRelationshipType(String relationshipTypeName);

    Optional<CypherPropertyKeyElement> findPropertyKey(String propertyKeyName);

    Optional<CypherProcedureElement> findProcedure(String fullName);

    Optional<CypherUserFunctionElement> findUserFunction(String fullName);
}
